Index: tests/regression/Parser/Tremolo/post/water_multipletimesteps.data
===================================================================
--- tests/regression/Parser/Tremolo/post/water_multipletimesteps.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
+++ tests/regression/Parser/Tremolo/post/water_multipletimesteps.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
@@ -0,0 +1,9 @@
+# ATOMDATA	Id	type	x=3	neighbors=4
+# Box	20	0	0	0	20	0	0	0	20
+1	O	0	0	0	2	3	0	0	
+2	H	0.759	0	0.504	1	0	0	0	
+3	H	0.759	0	-0.504	1	0	0	0	
+# ATOMDATA	Id	type	x=3	neighbors=4
+1	O	0.001	0	0	2	3	0	0	
+2	H	0.761	0	0.504	1	0	0	0	
+3	H	0.761	0	-0.504	1	0	0	0	
Index: tests/regression/Parser/Tremolo/post/water_multipletimesteps_fail.data
===================================================================
--- tests/regression/Parser/Tremolo/post/water_multipletimesteps_fail.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
+++ tests/regression/Parser/Tremolo/post/water_multipletimesteps_fail.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
@@ -0,0 +1,4 @@
+# ATOMDATA	Id	type	x=3	neighbors=4
+1	O	0	0	0	2	3	0	0	
+2	H	0.759	0	0.504	1	0	0	0	
+3	H	0.759	0	-0.504	1	0	0	0	
Index: tests/regression/Parser/Tremolo/pre/water_multipletimesteps.data
===================================================================
--- tests/regression/Parser/Tremolo/pre/water_multipletimesteps.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
+++ tests/regression/Parser/Tremolo/pre/water_multipletimesteps.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
@@ -0,0 +1,8 @@
+# ATOMDATA	Id	type	x=3	neighbors=4
+1	O	0	0	0	2	3	0	0	
+2	H	0.759	0	0.504	1	0	0	0	
+3	H	0.759	0	-0.504	1	0	0	0	
+# ATOMDATA	Id	type	x=3	neighbors=4
+1	O	0.001	0	0	2	3	0	0	
+2	H	0.761	0	0.504	1	0	0	0	
+3	H	0.761	0	-0.504	1	0	0	0	
Index: tests/regression/Parser/Tremolo/pre/water_multipletimesteps_fail.data
===================================================================
--- tests/regression/Parser/Tremolo/pre/water_multipletimesteps_fail.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
+++ tests/regression/Parser/Tremolo/pre/water_multipletimesteps_fail.data	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
@@ -0,0 +1,8 @@
+# ATOMDATA	Id	type	x=3	neighbors=4
+1	O	0	0	0	2	3	0	0	
+2	H	0.759	0	0.504	1	0	0	0	
+3	H	0.759	0	-0.504	1	0	0	0	
+# ATOMDATA	Id	type	x=3	u=3	neighbors=4
+1	O	0.001	0	0	0	0	0	2	3	0	0	
+2	H	0.761	0	0.504	0	0	0	1	0	0	0	
+3	H	0.761	0	-0.504	0	0	0	1	0	0	0	
Index: tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load-multiple-timesteps.at
===================================================================
--- tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load-multiple-timesteps.at	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
+++ tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load-multiple-timesteps.at	(revision 220d2ca22005430f3a42d5969387e88a1e532d20)
@@ -0,0 +1,65 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### parsing tremolo
+
+
+AT_SETUP([Parser - loading tremolo file with multiple timesteps])
+AT_KEYWORDS([parser load tremolo timesteps])
+# ::save() does not yet support multiple time steps
+AT_XFAIL_IF([/bin/true])
+
+file=water_multipletimesteps.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/tests/regression/Parser/Tremolo/post/$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - loading tremolo file with multiple timesteps with Undo])
+AT_KEYWORDS([parser load tremolo timesteps undo])
+# with undo we don't notice missing save() implementation
+AT_XFAIL_IF([/bin/false])
+
+file=water_multipletimesteps.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$file --undo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/tests/regression/Parser/Tremolo/post/empty.data], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - loading tremolo file with multiple timesteps with Redo])
+AT_KEYWORDS([parser load tremolo redo])
+# ::save() does not yet support multiple time steps
+AT_XFAIL_IF([/bin/true])
+
+file=water_multipletimesteps.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$file --undo --redo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/tests/regression/Parser/Tremolo/post/$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Parser - loading tremolo file with multiple timesteps fail])
+AT_KEYWORDS([parser load tremolo timesteps])
+
+file=water_multipletimesteps_fail.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/tests/regression/Parser/Tremolo/post/$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+