Index: tests/regression/Tesselation/3/post/NonConvexEnvelope.dat
===================================================================
--- tests/regression/Tesselation/3/post/NonConvexEnvelope.dat	(revision 15b670b004539c99ea55f410a0b9129ca76edf7c)
+++ tests/regression/Tesselation/3/post/NonConvexEnvelope.dat	(revision 274d45ac1a71ab65f0579050d6a972f174caf5e2)
@@ -2,4 +2,5 @@
 VARIABLES = "X" "Y" "Z" "U"
 ZONE T="test", N=44, E=86, DATAPACKING=POINT, ZONETYPE=FETRIANGLE
+6.9077 1.1106 0.1214 1
 0.3612 -3.628 1.323 1
 0.4884 -3.5983 -0.4521 3
@@ -45,90 +46,89 @@
 -6.8554 1.8134 -0.9499 1
 7.1391 2.0447 0.0264 0
-6.9077 1.1106 0.1214 1
 
-31 43 44
-31 34 44
-33 34 44
-22 31 34
-16 22 34
-7 16 34
-7 9 16
-2 7 9
-2 7 34
-2 3 34
-3 28 34
-28 33 34
-1 2 3
-1 3 28
-1 14 28
-14 27 28
-27 28 33
-1 6 14
-6 13 14
-13 14 27
-13 24 27
-24 27 36
-27 33 36
-33 36 44
-36 43 44
-24 25 36
-24 25 26
-25 26 32
-25 32 43
-25 36 43
-13 24 26
-13 26 29
-5 13 29
-5 23 29
-23 29 35
-29 35 38
-26 29 38
-26 29 38
-15 26 29
-15 17 29
-15 17 26
-17 26 32
-17 22 32
-5 6 23
-5 6 13
-6 10 23
-10 19 23
-19 23 40
-23 35 40
-35 40 41
-10 19 21
-4 10 21
-4 6 10
-1 4 6
-35 37 38
-35 37 41
-17 29 30
-29 30 38
-30 38 39
-8 17 30
-8 16 17
-16 17 22
-8 18 30
-8 12 18
-12 18 30
-12 20 30
-20 30 42
-30 39 42
-8 11 12
-8 9 11
-8 9 16
-11 12 20
-11 20 21
-4 11 21
-2 4 11
-1 2 4
-2 9 11
-19 20 21
-19 20 40
-20 40 42
-40 41 42
-22 31 32
-31 32 43
-39 41 42
-37 39 41
-37 38 39
+1 32 44
+1 32 35
+1 34 35
+23 32 35
+17 23 35
+8 17 35
+8 10 17
+3 8 10
+3 8 35
+3 4 35
+4 29 35
+29 34 35
+2 3 4
+2 4 29
+2 15 29
+15 28 29
+28 29 34
+2 7 15
+7 14 15
+14 15 28
+14 25 28
+25 28 37
+28 34 37
+1 34 37
+1 37 44
+25 26 37
+25 26 27
+26 27 33
+26 33 44
+26 37 44
+14 25 27
+14 27 30
+6 14 30
+6 24 30
+24 30 36
+30 36 39
+27 30 39
+27 30 39
+16 27 30
+16 18 30
+16 18 27
+18 27 33
+18 23 33
+6 7 24
+6 7 14
+7 11 24
+11 20 24
+20 24 41
+24 36 41
+36 41 42
+11 20 22
+5 11 22
+5 7 11
+2 5 7
+36 38 39
+36 38 42
+18 30 31
+30 31 39
+31 39 40
+9 18 31
+9 17 18
+17 18 23
+9 19 31
+9 13 19
+13 19 31
+13 21 31
+21 31 43
+31 40 43
+9 12 13
+9 10 12
+9 10 17
+12 13 21
+12 21 22
+5 12 22
+3 5 12
+2 3 5
+3 10 12
+20 21 22
+20 21 41
+21 41 43
+41 42 43
+23 32 33
+32 33 44
+40 42 43
+38 40 42
+38 39 40
Index: tests/regression/Tesselation/3/post/NonConvexEnvelope.r3d
===================================================================
--- tests/regression/Tesselation/3/post/NonConvexEnvelope.r3d	(revision 15b670b004539c99ea55f410a0b9129ca76edf7c)
+++ tests/regression/Tesselation/3/post/NonConvexEnvelope.r3d	(revision 274d45ac1a71ab65f0579050d6a972f174caf5e2)
@@ -3,4 +3,60 @@
 # All atoms as spheres
 2
+  0.939662 -3.01666 0.414493 	0.1	1. 1. 1.
+2
+  -0.152738 -1.94716 0.354093 	0.1	1. 1. 1.
+2
+  0.0659622 -1.03376 -0.880907 	0.1	1. 1. 1.
+2
+  -1.50434 -2.59696 0.0723932 	0.1	1. 1. 1.
+2
+  -0.0717378 -1.05346 1.57779 	0.1	1. 1. 1.
+2
+  1.52186 -0.603155 -0.873807 	0.1	1. 1. 1.
+2
+  -0.346038 -1.95996 -2.03011 	0.1	1. 1. 1.
+2
+  -2.63434 -1.74086 0.647893 	0.1	1. 1. 1.
+2
+  -1.61364 -2.66266 -1.47131 	0.1	1. 1. 1.
+2
+  1.36626 -0.519255 1.65039 	0.1	1. 1. 1.
+2
+  1.74646 0.246745 0.389693 	0.1	1. 1. 1.
+2
+  1.78606 0.287745 -2.09451 	0.1	1. 1. 1.
+2
+  -2.65324 -0.381955 -0.0548068 	0.1	1. 1. 1.
+2
+  -3.97304 -2.44796 0.426993 	0.1	1. 1. 1.
+2
+  3.21726 0.635145 0.478793 	0.1	1. 1. 1.
+2
+  3.13516 0.931145 -1.97401 	0.1	1. 1. 1.
+2
+  -3.80794 0.459345 0.492693 	0.1	1. 1. 1.
+2
+  3.34736 1.81094 1.44919 	0.1	1. 1. 1.
+2
+  3.76986 1.05884 -0.855107 	0.1	1. 1. 1.
+2
+  4.05806 -0.522555 1.01199 	0.1	1. 1. 1.
+2
+  -3.82684 1.81824 -0.210007 	0.1	1. 1. 1.
+2
+  5.16496 1.66244 -0.848507 	0.1	1. 1. 1.
+2
+  5.48576 -0.422855 0.476393 	0.1	1. 1. 1.
+2
+  -4.98154 2.65954 0.337493 	0.1	1. 1. 1.
+2
+  5.91796 1.03174 0.331693 	0.1	1. 1. 1.
+2
+  -5.00044 4.01854 -0.365207 	0.1	1. 1. 1.
+2
+  -6.30524 1.93554 0.0833932 	0.1	1. 1. 1.
+2
+  7.32406 1.08574 0.0829932 	0.1	1. 1. 1.
+2
   0.777562 -3.65286 1.28459 	0.1	1. 1. 1.
 2
@@ -94,60 +150,4 @@
 2
   7.55546 2.01984 -0.0120068 	0.1	1. 1. 1.
-2
-  0.939662 -3.01666 0.414493 	0.1	1. 1. 1.
-2
-  -0.152738 -1.94716 0.354093 	0.1	1. 1. 1.
-2
-  0.0659622 -1.03376 -0.880907 	0.1	1. 1. 1.
-2
-  -1.50434 -2.59696 0.0723932 	0.1	1. 1. 1.
-2
-  -0.0717378 -1.05346 1.57779 	0.1	1. 1. 1.
-2
-  1.52186 -0.603155 -0.873807 	0.1	1. 1. 1.
-2
-  -0.346038 -1.95996 -2.03011 	0.1	1. 1. 1.
-2
-  -2.63434 -1.74086 0.647893 	0.1	1. 1. 1.
-2
-  -1.61364 -2.66266 -1.47131 	0.1	1. 1. 1.
-2
-  1.36626 -0.519255 1.65039 	0.1	1. 1. 1.
-2
-  1.74646 0.246745 0.389693 	0.1	1. 1. 1.
-2
-  1.78606 0.287745 -2.09451 	0.1	1. 1. 1.
-2
-  -2.65324 -0.381955 -0.0548068 	0.1	1. 1. 1.
-2
-  -3.97304 -2.44796 0.426993 	0.1	1. 1. 1.
-2
-  3.21726 0.635145 0.478793 	0.1	1. 1. 1.
-2
-  3.13516 0.931145 -1.97401 	0.1	1. 1. 1.
-2
-  -3.80794 0.459345 0.492693 	0.1	1. 1. 1.
-2
-  3.34736 1.81094 1.44919 	0.1	1. 1. 1.
-2
-  3.76986 1.05884 -0.855107 	0.1	1. 1. 1.
-2
-  4.05806 -0.522555 1.01199 	0.1	1. 1. 1.
-2
-  -3.82684 1.81824 -0.210007 	0.1	1. 1. 1.
-2
-  5.16496 1.66244 -0.848507 	0.1	1. 1. 1.
-2
-  5.48576 -0.422855 0.476393 	0.1	1. 1. 1.
-2
-  -4.98154 2.65954 0.337493 	0.1	1. 1. 1.
-2
-  5.91796 1.03174 0.331693 	0.1	1. 1. 1.
-2
-  -5.00044 4.01854 -0.365207 	0.1	1. 1. 1.
-2
-  -6.30524 1.93554 0.0833932 	0.1	1. 1. 1.
-2
-  7.32406 1.08574 0.0829932 	0.1	1. 1. 1.
 # All tesselation triangles
 8
@@ -156,9 +156,9 @@
   BACKFACE  0.3 0.3 1.0   0 0
 1
-  5.67566 1.42984 -1.78291 	7.55546 2.01984 -0.0120068 	7.32406 1.08574 0.0829932 	1. 0. 0.
-1
-  5.67566 1.42984 -1.78291 	5.53756 -0.911555 -0.496607 	7.32406 1.08574 0.0829932 	1. 0. 0.
-1
-  6.16236 -0.927955 1.16559 	5.53756 -0.911555 -0.496607 	7.32406 1.08574 0.0829932 	1. 0. 0.
+  7.32406 1.08574 0.0829932 	5.67566 1.42984 -1.78291 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  7.32406 1.08574 0.0829932 	5.67566 1.42984 -1.78291 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  7.32406 1.08574 0.0829932 	6.16236 -0.927955 1.16559 	5.53756 -0.911555 -0.496607 	1. 0. 0.
 1
   3.60736 1.29684 -2.87381 	5.67566 1.42984 -1.78291 	5.53756 -0.911555 -0.496607 	1. 0. 0.
@@ -202,7 +202,7 @@
   4.07696 -0.484155 2.10119 	6.16236 -0.927955 1.16559 	5.68906 1.58194 1.24439 	1. 0. 0.
 1
-  6.16236 -0.927955 1.16559 	5.68906 1.58194 1.24439 	7.32406 1.08574 0.0829932 	1. 0. 0.
-1
-  5.68906 1.58194 1.24439 	7.55546 2.01984 -0.0120068 	7.32406 1.08574 0.0829932 	1. 0. 0.
+  7.32406 1.08574 0.0829932 	6.16236 -0.927955 1.16559 	5.68906 1.58194 1.24439 	1. 0. 0.
+1
+  7.32406 1.08574 0.0829932 	5.68906 1.58194 1.24439 	7.55546 2.01984 -0.0120068 	1. 0. 0.
 1
   3.22946 1.45274 2.47189 	4.33006 2.26874 1.33549 	5.68906 1.58194 1.24439 	1. 0. 0.