Index: tests/regression/Atoms/Add/post/test.data
===================================================================
--- tests/regression/Atoms/Add/post/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Atoms/Add/post/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,2 +1,2 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	H	0	0	-	-	-	0	-	0	0	0	0	-	0	0	0	10	10	10	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	0	0	0	0	-	H	0	0	0	10	10	10	
Index: tests/regression/Filling/FillVoidWithMolecule/post/tensid.data
===================================================================
--- tests/regression/Filling/FillVoidWithMolecule/post/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Filling/FillVoidWithMolecule/post/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	17.397	20.231	11.737	Na	0	0	0	0	1.000000e+00	
 2	S	SLES	1	16.282	18.88	14.208	S	3	4	5	6	1.330000e+00	
Index: tests/regression/Filling/FillVoidWithMolecule/pre/tensid.data
===================================================================
--- tests/regression/Filling/FillVoidWithMolecule/pre/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Filling/FillVoidWithMolecule/pre/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	17.397	20.231	11.737	Na	0	0	0	0	1.000000e+00	
 2	S	SLES	1	16.282	18.88	14.208	S	3	4	5	6	1.330000e+00	
Index: tests/regression/Filling/FillVoidWithMolecule/pre/water.data
===================================================================
--- tests/regression/Filling/FillVoidWithMolecule/pre/water.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Filling/FillVoidWithMolecule/pre/water.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	-	-	0	0.	0.	0.	O	2	3	0	0	0
 2	-	-	0	0.758602	0.	0.504284	H	1	0	0	0	0
Index: tests/regression/Molecules/Copy/post/tensid.data
===================================================================
--- tests/regression/Molecules/Copy/post/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Molecules/Copy/post/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	32.397	35.231	26.737	NA	0	0	0	0	1.000000e+00	
 2	S	SLES	1	31.282	33.88	29.208	SL	3	4	5	6	1.330000e+00	
Index: tests/regression/Molecules/Copy/pre/tensid.data
===================================================================
--- tests/regression/Molecules/Copy/pre/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Molecules/Copy/pre/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	32.397	35.231	26.737	NA	0	0	0	0	1.000000e+00	
 2	S	SLES	1	31.282	33.88	29.208	SL	3	4	5	6	1.330000e+00	
Index: tests/regression/Parser/Tremolo-Potentials/post/argon.data
===================================================================
--- tests/regression/Parser/Tremolo-Potentials/post/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo-Potentials/post/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	Type	x=3
+# ATOMDATA	Id	name	type	x=3
 1	Ar1	Argon	4.72977	8	8	
 2	Ar2	Argon	7.3	8	8	
Index: tests/regression/Parser/Tremolo-Potentials/post/test.data
===================================================================
--- tests/regression/Parser/Tremolo-Potentials/post/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo-Potentials/post/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	Ar	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	4.72977	8	8	
-0	0	0	0	2	Ar	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	7.3	8	8	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	   1	0	0	0	-	Ar	0	0	0	4.72977	8	8	
+0	0	0	0	2	0	0	-	-	-	0	-	   1	0	0	0	-	Ar	0	0	0	7.3	8	8	
Index: tests/regression/Parser/Tremolo-Potentials/pre/argon.data
===================================================================
--- tests/regression/Parser/Tremolo-Potentials/pre/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo-Potentials/pre/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA Id name Type x=3
+# ATOMDATA Id name type x=3
 1	Ar1	Argon	4.72977074	8.	8.	
 2	Ar2	Argon	7.3		8.		8.		
Index: tests/regression/Parser/Tremolo/post/argon.data
===================================================================
--- tests/regression/Parser/Tremolo/post/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/post/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	Type	x=3
+# ATOMDATA	Id	name	type	x=3
 1	Ar1	Ar	4.72977	8	8	
 2	Ar2	Ar	7.3	8	8	
Index: tests/regression/Parser/Tremolo/post/test.data
===================================================================
--- tests/regression/Parser/Tremolo/post/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/post/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,2 +1,2 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	H	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	10	10	10	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	   1	0	0	0	-	H	0	0	0	10	10	10	
Index: tests/regression/Parser/Tremolo/pre/argon.data
===================================================================
--- tests/regression/Parser/Tremolo/pre/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/pre/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA Id name Type x=3
+# ATOMDATA Id name type x=3
 1	Ar1	Ar	4.72977074	8.	8.	
 ###2	3	4	5
Index: tests/regression/Parser/Tremolo/pre/test.data
===================================================================
--- tests/regression/Parser/Tremolo/pre/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/pre/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,2 +1,2 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	H	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	10	10	10	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	   1	0	0	0	-	H	0	0	0	10	10	10	